Subject: Re: [V2, 06/12] selftests, powerpc: Add test for system wide DSCR default

From: Anshuman Khandual <[email-masked]>
Date: Thu, 09 Apr 2015 18:08:11 +0530

On 04/09/2015 04:01 PM, Anshuman Khandual wrote:
> On 03/27/2015 05:31 PM, Michael Ellerman wrote:
>> On Tue, 2015-13-01 at 10:22:34 UTC, Anshuman Khandual wrote:
>>> This patch adds a test case for the system wide DSCR default
>>> value, which when changed through it's sysfs interface must
>>> be visible to all threads reading DSCR either through the
>>> privilege state SPR or the problem state SPR. The DSCR value
>>> change should be immediate as well.
>>
>> ...
>>
>>> +
>>> +/* Default DSCR access */
>>> +unsigned long get_default_dscr(void)
>>> +{
>>> +	int fd = -1;
>>> +	char buf[16];
>>> +	unsigned long val;
>>> +
>>> +	if (fd == -1) {
>>> +		fd = open(DSCR_DEFAULT, O_RDONLY);
>>> +		if (fd == -1) {
>>> +			perror("open() failed\n");
>>> +			exit(1);
>>> +		}
>>> +	}
>>> +	memset(buf, 0, sizeof(buf));
>>> +	lseek(fd, 0, SEEK_SET);
>>> +	read(fd, buf, sizeof(buf));
>>
> 
> Normally, I build the test cases like
> 
> $cd tools/testing/selftests/powerpc/
> $make dscr
> 
> with these compiler flags "-Wall -O2 -flto -Wall -Werror" which
> is still working for me. Then I figured out that the read and
> write declaration in unistd.h header file has "_wur" in it.
> 
> extern ssize_t read (int __fd, void *__buf, size_t __nbytes) __wur;
> extern ssize_t write (int __fd, const void *__buf, size_t __n) __wur;
> 
> Then some how the compiler (GCC 4.8.3) is not complaining about it.
> 
>>
>> This and the other tests are failing to build:
>>
>>     In file included from dscr_default_test.c:16:0:
>>     dscr.h: In function â€˜get_default_dscrâ€™:
>>     dscr.h:93:6: error: ignoring return value of â€˜readâ€™, declared with attribute warn_unused_result [-Werror=unused-result]
>>       read(fd, buf, sizeof(buf));
>>           ^
>>     dscr.h: In function â€˜set_default_dscrâ€™:
>>     dscr.h:112:7: error: ignoring return value of â€˜writeâ€™, declared with attribute warn_unused_result [-Werror=unused-result]
>>       write(fd, buf, strlen(buf));
>>            ^
>>     cc1: all warnings being treated as errors
> 
> Anyways, I can change the header file helper functions if you would like.
> BTW, the patch series does not apply as it is and requires rebasing. Would
> send out a new version of it.

The rebased patch series works as expected like this version and all the tests
pass. I would add a  .gitignore file for this new test directory. Please let me
know if there are other changes which need to be done. Thanks !!